#include <assert.h>
#include <stdio.h>
#include <stdlib.h>

#include "bignum.h"

#define BNUM_NEGATIVE(num) ((num)->sign == 1)
#define BNUM_POSITIVE(num) ((num)->sign == 0)
#define BNUM_SIGNEQ(num1, num2) ((num1)->sign == (num2)->sign)

int 
bnum_cmp(const struct bignum *a, const struct bignum *b)
{
	int i;
	int res;

	assert((a != NULL) && (b != NULL));

	if (!BNUM_SIGNEQ(a, b))
		if (((a->val > 0) && (b->val > 0)) &&
		 ((a->val[0] != 0x0) || (b->val[0] != 0x0)))
			return BNUM_POSITIVE(a) ? 1: -1;

	if (a->top > b->top)
		res = 1;
	else if (a->top < b->top)
		res = -1;
	else {
		res = 0;
		for (i = 0; i <= a->top; i++)
			if (a->val[i] > b->val[i]) {
				res = 1;
				break;
			} else if (a->val[i] < b->val[i]) {
				res = -1;
				break;
			}
	}

	if (BNUM_NEGATIVE(a))
		res = -res; 	

	return res;	
}
